"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
var prostore_apollo_1 = require("@proscom/prostore-apollo");
var prostore_react_1 = require("@proscom/prostore-react");
var ApolloClientsContext_1 = require("./ApolloClientsContext");
function useGraphqlQuery(_a) {
    var client = _a.client, queryOptions = _a.queryOptions, variables = _a.variables, options = _a.options;
    var actualClient = ApolloClientsContext_1.useContextApolloClient(client);
    var store = react_1.useMemo(function () {
        return new prostore_apollo_1.GraphqlQueryStore(__assign({ client: actualClient }, queryOptions));
    }, [actualClient, queryOptions]);
    return prostore_react_1.useRequestStore(store, variables, options);
}
exports.useGraphqlQuery = useGraphqlQuery;
function useGraphqlQueryVars(_a) {
    var variableCreator = _a.variableCreator, queryProps = __rest(_a, ["variableCreator"]);
    var variables = react_1.useMemo.apply(void 0, variableCreator);
    return useGraphqlQuery(__assign({}, queryProps, { variables: variables }));
}
exports.useGraphqlQueryVars = useGraphqlQueryVars;
//# sourceMappingURL=useGraphqlQuery.js.map